unless window.coffeetable then window.coffeetable = {}
app = window.coffeetable

app.gen_handlers = {

	toggle_activated: (el) -> 

		###

		Adds class 'active' to `el` and redraws `el`'s buttons. Triggers a beatmap redraw.

		###

		active = $(el).closest('.generator-box').toggleClass('active').hasClass('active')
		color = if active then 'black' else '#C1CDCD'
		$('.up', el).each(-> app.button.draw_triangle(this, color, 'up'))
		$('.down', el).each(-> app.button.draw_triangle(this, color, 'down'))
		app.beatmap.redraw()

	init_activator: (gen_el) ->

		###

		Causes the activator (an 'X' inside `gen_el`) to toggle activation status
		and have tooltips.

		###

		$('.glyphs > span:last-child', gen_el)
		.click((event) ->
			if event.target == this
				app.gen_handlers.toggle_activated(gen_el))
		.each(->
			app.tooltips.activator(this))

	init: ->

		###

		Initializes all activators and up/down buttons.

		###
		app.button.set_datalist('#rhythm', [1..32], 'step-range')
		app.button.set_datalist('#rhythm', [0..32], 'offset-range')

		$('.generator-box').each(
			(index, gen_el) ->
				color = if $(this).hasClass('active') then 'black' else '#C1CDCD'
				[step, offset] = $('.step, .offset', gen_el)
				app.gen_handlers.init_activator(gen_el)
				# FIX ME! app.parameter.gen_max() doesn't seem to work on page load, 
				# but later it does (perplexingly)
				app.button.init(step, 'step-range', 'step', color, app.beatmap.redraw)
				app.button.init(offset, 'offset-range', 'offset', color, app.beatmap.redraw)) 
}
