(function() {
  var app;

  if (!window.coffeetable) window.coffeetable = {};

  app = window.coffeetable;

  app.gen_handlers = {
    toggle_activated: function(el) {
      /*
      
      		Adds class 'active' to `el` and redraws `el`'s buttons. Triggers a beatmap redraw.
      */
      var active, color;
      active = $(el).closest('.generator-box').toggleClass('active').hasClass('active');
      color = active ? 'black' : '#C1CDCD';
      $('.up', el).each(function() {
        return app.button.draw_triangle(this, color, 'up');
      });
      $('.down', el).each(function() {
        return app.button.draw_triangle(this, color, 'down');
      });
      return app.beatmap.redraw();
    },
    init_activator: function(gen_el) {
      /*
      
      		Causes the activator (an 'X' inside `gen_el`) to toggle activation status
      		and have tooltips.
      */      return $('.glyphs > span:last-child', gen_el).click(function(event) {
        if (event.target === this) {
          return app.gen_handlers.toggle_activated(gen_el);
        }
      }).each(function() {
        return app.tooltips.activator(this);
      });
    },
    init: function() {
      /*
      
      		Initializes all activators and up/down buttons.
      */
      var _i, _j, _results, _results2;
      app.button.set_datalist('#rhythm', (function() {
        _results = [];
        for (_i = 1; _i <= 32; _i++){ _results.push(_i); }
        return _results;
      }).apply(this), 'step-range');
      app.button.set_datalist('#rhythm', (function() {
        _results2 = [];
        for (_j = 0; _j <= 32; _j++){ _results2.push(_j); }
        return _results2;
      }).apply(this), 'offset-range');
      return $('.generator-box').each(function(index, gen_el) {
        var color, offset, step, _ref;
        color = $(this).hasClass('active') ? 'black' : '#C1CDCD';
        _ref = $('.step, .offset', gen_el), step = _ref[0], offset = _ref[1];
        app.gen_handlers.init_activator(gen_el);
        app.button.init(step, 'step-range', 'step', color, app.beatmap.redraw);
        return app.button.init(offset, 'offset-range', 'offset', color, app.beatmap.redraw);
      });
    }
  };

}).call(this);
