(function() {
  var app;

  if (!window.coffeetable) window.coffeetable = {};

  app = window.coffeetable;

  app.list_handlers = {
    toggle_selection: function(el) {
      /*
      
      		Adds class `selected` to `el`, removes it from any of `el`s siblings, and triggers
      		a canvas redraw to reflect the change.
      */      $(el).closest('ul').find('.selected').toggleClass('selected');
      $(el).toggleClass('selected');
      return app.beatmap.redraw();
    },
    show_selections: function(el) {
      return $('li', el).slideDown(200);
    },
    expand_to_show_selections: function(ul, wrapper) {
      var new_h, wrapper_h;
      wrapper_h = $(wrapper).height();
      $('li', ul).show();
      new_h = wrapper_h + $(ul).height();
      $('li', ul).hide();
      $(wrapper).animate({
        height: new_h
      }, 210);
      return app.list_handlers.show_selections(ul);
    },
    hide_all_but_selected: function(el) {
      /*
      
      		Pops `el` (a `<li>`) out of the list, slides `el`'s siblings up out of view, and
      		then re-attaches `el` to the list (so that it's the only visible option).
      */
      var selected, show_selected;
      selected = $('.selected', el).detach();
      $('li', el).slideUp(200);
      show_selected = function() {
        return $(el).prepend(selected);
      };
      return setTimeout(show_selected, 200);
    },
    contract_to_hide: function(ul, wrapper, reset_h) {
      $(wrapper).animate({
        height: reset_h
      }, 210);
      return app.list_handlers.hide_all_but_selected(ul);
    },
    init: function() {
      /*
      
      		Causes lists to expand and contract; to show tooltips; to toggle class `selected`.
      */
      var controls_and_rhythm, default_wrapper_h, pitch_wrapper;
      controls_and_rhythm = $('#control-panel, #rhythm');
      pitch_wrapper = $('#pitch');
      default_wrapper_h = $('#pitch').height();
      $('li', controls_and_rhythm).click(function() {
        return app.list_handlers.toggle_selection(this);
      });
      $('ul', controls_and_rhythm).mouseenter(function() {
        return app.list_handlers.show_selections(this);
      });
      $('ul', controls_and_rhythm).mouseleave(function() {
        return app.list_handlers.hide_all_but_selected(this);
      }).trigger('mouseleave');
      return setTimeout(app.tooltips.toggle_boxes, 200);
    }
  };

}).call(this);
