unless window.coffeetable then window.coffeetable = {}
app = window.coffeetable

app.parameters = {

	measures: -> # integer value of the user-selected measure count
		parseInt($('.measures .selected').first().text())
	
	resolution: -> # integer value of the user-selected resolution
		parseInt($('.resolution .selected').first().text())
	
	envelope: -> 

		###

		Returns an array containing the integer values of 4 slider elements, in order:
		`[attack, decay, sustain, release]`. The sliders are gotten by ID.

		###

		values = []
		$('#attack, #decay, #sustain, #release').each((i, el) ->
			values.push($(el).slider('value')))
		values

	reset_gen_max: ->
		new_max = app.parameters.measures() * app.parameters.resolution()
		app.button.reset_datalist([1..new_max], 'step-range')
		app.button.reset_datalist([0..new_max], 'offset-range')


	envelope_init: ->

		###

		Converts each of the 4 envelope sliders (attack, decay, sustain, release) into
		an actual slider (using the jQuery UI plugin). Sets their default values and 
		causes the beatmap to be redrawn on change.

		###

		defaults = [10, 75, 50, 25] # a d s r
		$('#envelope .slider')
		.each((i, el) -> $(el).slider(
			{
				min: 1, 
				max: 100, 
				value: defaults[i], 
				orientation: 'vertical'
				change: (event, ui) -> app.beatmap.redraw()
			}))

	init: ->
		app.parameters.envelope_init()

		$('.measures li, .resolution li').click(
			->
				app.parameters.reset_gen_max()
				$('#rhythm input').each(
					(i, el) ->
						app.button.get_current_option(el)))
}
