(function() {
  var app;

  if (!window.coffeetable) window.coffeetable = {};

  app = window.coffeetable;

  app.parameters = {
    measures: function() {
      return parseInt($('.measures .selected').first().text());
    },
    resolution: function() {
      return parseInt($('.resolution .selected').first().text());
    },
    envelope: function() {
      /*
      
      		Returns an array containing the integer values of 4 slider elements, in order:
      		`[attack, decay, sustain, release]`. The sliders are gotten by ID.
      */
      var values;
      values = [];
      $('#attack, #decay, #sustain, #release').each(function(i, el) {
        return values.push($(el).slider('value'));
      });
      return values;
    },
    reset_gen_max: function() {
      var new_max, _i, _j, _results, _results2;
      new_max = app.parameters.measures() * app.parameters.resolution();
      app.button.reset_datalist((function() {
        _results = [];
        for (var _i = 1; 1 <= new_max ? _i <= new_max : _i >= new_max; 1 <= new_max ? _i++ : _i--){ _results.push(_i); }
        return _results;
      }).apply(this), 'step-range');
      return app.button.reset_datalist((function() {
        _results2 = [];
        for (var _j = 0; 0 <= new_max ? _j <= new_max : _j >= new_max; 0 <= new_max ? _j++ : _j--){ _results2.push(_j); }
        return _results2;
      }).apply(this), 'offset-range');
    },
    envelope_init: function() {
      /*
      
      		Converts each of the 4 envelope sliders (attack, decay, sustain, release) into
      		an actual slider (using the jQuery UI plugin). Sets their default values and 
      		causes the beatmap to be redrawn on change.
      */
      var defaults;
      defaults = [10, 75, 50, 25];
      return $('#envelope .slider').each(function(i, el) {
        return $(el).slider({
          min: 1,
          max: 100,
          value: defaults[i],
          orientation: 'vertical',
          change: function(event, ui) {
            return app.beatmap.redraw();
          }
        });
      });
    },
    init: function() {
      app.parameters.envelope_init();
      return $('.measures li, .resolution li').click(function() {
        app.parameters.reset_gen_max();
        return $('#rhythm input').each(function(i, el) {
          return app.button.get_current_option(el);
        });
      });
    }
  };

}).call(this);
