unless window.coffeetable then window.coffeetable = {}
app = window.coffeetable

app.pitch_handlers = {

	notes: app.pitch.notes.get_arr()

	octaves: [-1..6]

	step_opts: [1...8]

	scales: [
		'major'
		'dorian'
		'phrygian'
		'lydian'
		'mixolydian'
		'aeolian'
		'locrian'
		'pentatonic'
		'minor pentatonic'
		'major pentatonic'
		'whole tone'
		'chromatic'
		'harmonic minor'
		'melodic minor asc'
		'hungarian minor'
	]

	patterns: [
		'up'
		'down'
	]

	get_selected_octave: ->
		parseInt($('.button-group.start-octave input').val())

	get_octave_range: ->
		this_oct = app.pitch_handlers.get_selected_octave()
		min = -(this_oct + 1)
		max = 6 - this_oct
		[min..max]

	init_pitch_option: (selector, data, data_label, label, color, on_clk) ->
		container = $(selector)
		console.log data
		app.button.set_datalist('#pitch-data', data, data_label)
		app.button.init(container, data_label, label, color, on_clk)

	root: -> ['.button-group.root', app.pitch.notes.get_arr(), 'note-names']

	start_octave: -> [
		'.button-group.start-octave', 
		app.pitch_handlers.octaves, 
		'octaves'
	]

	octave_range: -> [
		'.button-group.octave-range'
		app.pitch_handlers.get_octave_range()
		'octave-range'
	]

	reset_octave_range: ->
		$('.button-group.octave-range').children().remove()
		app.pitch_handlers.init_octave_range()

	steps: -> ['.button-group.steps', app.pitch_handlers.step_opts, 'steps']

	scale: -> [
		'.button-group.scale'
		app.pitch_handlers.scales
		'scale-names'
	]

	pattern: -> [
		'.button-group.pattern'
		app.pitch_handlers.patterns
		'pattern-names'
	]

	list_pitches: ->
		vars = []
		$('#pitch input').each(-> vars.push($(this).val()))
		console.log vars
		[root, start_octave, octave_range, steps, scale, pattern] = vars
		[start_octave, octave_range, steps] = (parseInt(x) for x in [start_octave, 
																	 octave_range, 
																	 steps])
		scale_name = scale.replace(/\s+/g, '_')
		octave_range = [start_octave..start_octave+octave_range]
		pitches = app.pitch.get_active_notes(root, scale_name, octave_range, steps, pattern)
		$('#pitch-names').text(pitches.join(', '))

	init: ->
		_.each([
			'root'
			'start_octave'
			'octave_range'
			'steps'
			'scale'
			'pattern'
		],
		(name) ->
			data = app.pitch_handlers[name]()
			data.push(name.split('_').join(' '))
			data.push('black')
			data.push(app.pitch_handlers.list_pitches)
			app.pitch_handlers.init_pitch_option.apply(null, data))
		app.pitch_handlers.list_pitches()
}	