(function() {
  var app;

  if (!window.coffeetable) window.coffeetable = {};

  app = window.coffeetable;

  app.pitch_handlers = {
    notes: app.pitch.notes.get_arr(),
    octaves: [-1, 0, 1, 2, 3, 4, 5, 6],
    step_opts: [1, 2, 3, 4, 5, 6, 7],
    scales: ['major', 'dorian', 'phrygian', 'lydian', 'mixolydian', 'aeolian', 'locrian', 'pentatonic', 'minor pentatonic', 'major pentatonic', 'whole tone', 'chromatic', 'harmonic minor', 'melodic minor asc', 'hungarian minor'],
    patterns: ['up', 'down'],
    get_selected_octave: function() {
      return parseInt($('.button-group.start-octave input').val());
    },
    get_octave_range: function() {
      var max, min, this_oct, _i, _results;
      this_oct = app.pitch_handlers.get_selected_octave();
      min = -(this_oct + 1);
      max = 6 - this_oct;
      return (function() {
        _results = [];
        for (var _i = min; min <= max ? _i <= max : _i >= max; min <= max ? _i++ : _i--){ _results.push(_i); }
        return _results;
      }).apply(this);
    },
    init_pitch_option: function(selector, data, data_label, label, color, on_clk) {
      var container;
      container = $(selector);
      console.log(data);
      app.button.set_datalist('#pitch-data', data, data_label);
      return app.button.init(container, data_label, label, color, on_clk);
    },
    root: function() {
      return ['.button-group.root', app.pitch.notes.get_arr(), 'note-names'];
    },
    start_octave: function() {
      return ['.button-group.start-octave', app.pitch_handlers.octaves, 'octaves'];
    },
    octave_range: function() {
      return ['.button-group.octave-range', app.pitch_handlers.get_octave_range(), 'octave-range'];
    },
    reset_octave_range: function() {
      $('.button-group.octave-range').children().remove();
      return app.pitch_handlers.init_octave_range();
    },
    steps: function() {
      return ['.button-group.steps', app.pitch_handlers.step_opts, 'steps'];
    },
    scale: function() {
      return ['.button-group.scale', app.pitch_handlers.scales, 'scale-names'];
    },
    pattern: function() {
      return ['.button-group.pattern', app.pitch_handlers.patterns, 'pattern-names'];
    },
    list_pitches: function() {
      var octave_range, pattern, pitches, root, scale, scale_name, start_octave, steps, vars, x, _i, _ref, _ref2, _results;
      vars = [];
      $('#pitch input').each(function() {
        return vars.push($(this).val());
      });
      console.log(vars);
      root = vars[0], start_octave = vars[1], octave_range = vars[2], steps = vars[3], scale = vars[4], pattern = vars[5];
      _ref = (function() {
        var _i, _len, _ref, _results;
        _ref = [start_octave, octave_range, steps];
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          x = _ref[_i];
          _results.push(parseInt(x));
        }
        return _results;
      })(), start_octave = _ref[0], octave_range = _ref[1], steps = _ref[2];
      scale_name = scale.replace(/\s+/g, '_');
      octave_range = (function() {
        _results = [];
        for (var _i = start_octave, _ref2 = start_octave + octave_range; start_octave <= _ref2 ? _i <= _ref2 : _i >= _ref2; start_octave <= _ref2 ? _i++ : _i--){ _results.push(_i); }
        return _results;
      }).apply(this);
      pitches = app.pitch.get_active_notes(root, scale_name, octave_range, steps, pattern);
      return $('#pitch-names').text(pitches.join(', '));
    },
    init: function() {
      _.each(['root', 'start_octave', 'octave_range', 'steps', 'scale', 'pattern'], function(name) {
        var data;
        data = app.pitch_handlers[name]();
        data.push(name.split('_').join(' '));
        data.push('black');
        data.push(app.pitch_handlers.list_pitches);
        return app.pitch_handlers.init_pitch_option.apply(null, data);
      });
      return app.pitch_handlers.list_pitches();
    }
  };

}).call(this);
