(function() {
  var app;

  if (!window.coffeetable) window.coffeetable = {};

  app = window.coffeetable;

  app.tooltips = {
    assign_tooltip: function(target, text) {
      /*
      
      		Causes `text` to appear in the #tooltips element whenever the user's mouse
      		hovers over `target`; erases `text` from #tooltips on exit from `target`.
      */      $(target).mouseenter(function() {
        return $('#tooltips').text(text);
      });
      return $(target).mouseleave(function() {
        return $('#tooltips').text('');
      });
    },
    toggle_boxes: function() {
      return $(".toggle-box li").each(function(i, el) {
        var type;
        type = $(el).text() === 'or' ? 'union' : 'intersection';
        return app.tooltips.assign_tooltip(el, "combine this row with " + type);
      });
    },
    activator: function(target) {
      return app.tooltips.assign_tooltip(target, "toggle active (bold and read) or inactive (faded and ignored)");
    },
    up_and_down_buttons: function(button, amt, type) {
      var action;
      action = amt > 0 ? 'raise' : 'lower';
      return app.tooltips.assign_tooltip(button, "press to " + action + " the " + type);
    }
  };

}).call(this);
